diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-phy-header.cc ns-3.33/src/wifi/model/wifi-phy-header.cc
--- ns-3.32/src/wifi/model/wifi-phy-header.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-phy-header.cc	2021-01-09 10:19:23.000000000 -0800
@@ -195,13 +195,10 @@
 void
 LSigHeader::SetRate (uint64_t rate, uint16_t channelWidth)
 {
-  if (channelWidth == 5)
-    {
-      rate *= 4; //corresponding 20 MHz rate if 5 MHz is used
-    }
-  else if (channelWidth == 10)
+  if (channelWidth < 20)
     {
-      rate *= 2; //corresponding 20 MHz rate if 10 MHz is used
+      //conversion for 5 MHz and 10 MHz
+      rate *= (20 / channelWidth);
     }
   /* Here is the binary representation for a given rate:
    * 6 Mbit/s: 1101
@@ -370,6 +367,7 @@
   os << "MCS=" << +m_mcs
      << " HT_LENGTH=" << m_htLength
      << " CHANNEL_WIDTH=" << GetChannelWidth ()
+     << " FEC_CODING=" << (m_fecCoding ? "LDPC" : "BCC")
      << " SGI=" << +m_sgi
      << " AGGREGATION=" << +m_aggregation;
 }
@@ -430,6 +428,18 @@
 }
 
 void
+HtSigHeader::SetFecCoding (bool ldpc)
+{
+  m_fecCoding = ldpc ? 1 : 0;
+}
+
+bool
+HtSigHeader::IsLdpcFecCoding (void) const
+{
+  return m_fecCoding ? true : false;
+}
+
+void
 HtSigHeader::SetShortGuardInterval (bool sgi)
 {
   m_sgi = sgi ? 1 : 0;
@@ -450,6 +460,7 @@
   start.WriteU16 (m_htLength);
   byte = (0x01 << 2); //Set Reserved bit #2 to 1
   byte |= ((m_aggregation & 0x01) << 3);
+  byte |= ((m_fecCoding & 0x01) << 6);
   byte |= ((m_sgi & 0x01) << 7);
   start.WriteU8 (byte);
   start.WriteU16 (0);
@@ -465,6 +476,7 @@
   m_htLength = i.ReadU16 ();
   byte = i.ReadU8 ();
   m_aggregation = ((byte >> 3) & 0x01);
+  m_fecCoding = ((byte >> 6) & 0x01);
   m_sgi = ((byte >> 7) & 0x01);
   i.ReadU16 ();
   return i.GetDistanceFrom (start);
@@ -510,6 +522,7 @@
      << " CHANNEL_WIDTH=" << GetChannelWidth ()
      << " SGI=" << +m_sgi
      << " NSTS=" << +m_nsts
+     << " CODING=" << (m_coding ? "LDPC" : "BCC")
      << " MU=" << +m_mu;
 }
 
@@ -612,6 +625,19 @@
 }
 
 void
+VhtSigHeader::SetCoding (bool ldpc)
+{
+  m_coding = ldpc ? 1 : 0;
+}
+
+bool
+VhtSigHeader::IsLdpcCoding (void) const
+{
+  return m_coding ? true : false;
+
+}
+
+void
 VhtSigHeader::SetSuMcs (uint8_t mcs)
 {
   NS_ASSERT (mcs <= 9);
@@ -638,6 +664,7 @@
   //VHT-SIG-A2
   byte = m_sgi & 0x01;
   byte |= ((m_sgi_disambiguation & 0x01) << 1);
+  byte |= ((m_coding & 0x01) << 2);
   byte |= ((m_suMcs & 0x0f) << 4);
   start.WriteU8 (byte);
   bytes = (0x01 << (9 - 8)); //Set Reserved bit #9 to 1
@@ -665,6 +692,7 @@
   byte = i.ReadU8 ();
   m_sgi = byte & 0x01;
   m_sgi_disambiguation = ((byte >> 1) & 0x01);
+  m_coding = ((byte >> 2) & 0x01);
   m_suMcs = ((byte >> 4) & 0x0f);
   i.ReadU16 ();
 
@@ -722,6 +750,7 @@
      << " GI=" << GetGuardInterval ()
      << " NSTS=" << +m_nsts
      << " BSSColor=" << +m_bssColor
+     << " CODING=" << (m_coding ? "LDPC" : "BCC")
      << " MU=" << +m_mu;
 }
 
@@ -865,6 +894,19 @@
 }
 
 void
+HeSigHeader::SetCoding (bool ldpc)
+{
+  m_coding = ldpc ? 1 : 0;
+}
+
+bool
+HeSigHeader::IsLdpcCoding (void) const
+{
+  return m_coding ? true : false;
+
+}
+
+void
 HeSigHeader::Serialize (Buffer::Iterator start) const
 {
   //HE-SIG-A1
@@ -883,6 +925,7 @@
 
   //HE-SIG-A2
   uint32_t sigA2 = 0;
+  sigA2 |= ((m_coding & 0x01) << 7);
   sigA2 |= (0x01 << 14); //Set Reserved bit #14 to 1
   start.WriteU32 (sigA2);
 
@@ -913,7 +956,8 @@
   m_nsts |= (byte & 0x03) << 1;
 
   //HE-SIG-A2
-  i.ReadU32 ();
+  uint32_t sigA2 = i.ReadU32 ();
+  m_coding = ((sigA2 >> 7) & 0x01);
 
   if (m_mu)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-phy-header.h ns-3.33/src/wifi/model/wifi-phy-header.h
--- ns-3.32/src/wifi/model/wifi-phy-header.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-phy-header.h	2021-01-09 10:19:23.000000000 -0800
@@ -197,6 +197,18 @@
    */
   bool GetAggregation (void) const;
   /**
+   * Fill the FEC coding field of HT-SIG.
+   *
+   * \param ldpc whether LDPC is used or not
+   */
+  void SetFecCoding (bool ldpc);
+  /**
+   * Return whether LDPC is used or not.
+   *
+   * \return whether LDPC is used or not
+   */
+  bool IsLdpcFecCoding (void) const;
+  /**
    * Fill the short guard interval field of HT-SIG.
    *
    * \param sgi whether short guard interval is used or not
@@ -227,6 +239,7 @@
   uint8_t m_cbw20_40;    ///< CBW 20/40
   uint16_t m_htLength;   ///< HT length
   uint8_t m_aggregation; ///< Aggregation
+  uint8_t m_fecCoding;   ///< FEC coding (0 for BCC or 1 for LDPC)
   uint8_t m_sgi;         ///< Short Guard Interval
 };
 
@@ -310,6 +323,18 @@
    */
   bool GetShortGuardIntervalDisambiguation (void) const;
   /**
+   * Fill the coding field of VHT-SIG-A2.
+   *
+   * \param ldpc whether LDPC is used or not
+   */
+  void SetCoding (bool ldpc);
+  /**
+   * Return whether LDPC is used or not.
+   *
+   * \return whether LDPC is used or not
+   */
+  bool IsLdpcCoding (void) const;
+  /**
    * Fill the SU VHT MCS field of VHT-SIG-A2.
    *
    * \param mcs the SU VHT MCS field of VHT-SIG-A2
@@ -331,6 +356,7 @@
   //VHT-SIG-A2 fields
   uint8_t m_sgi;                ///< Short GI
   uint8_t m_sgi_disambiguation; ///< Short GI NSYM Disambiguation
+  uint8_t m_coding;             ///< SU/MU coding (0 for BCC, 1 for LDPC)
   uint8_t m_suMcs;              ///< SU VHT MCS
 
   /// This is used to decide whether MU SIG-B should be added or not
@@ -428,7 +454,18 @@
    * \return the number of streams
    */
   uint8_t GetNStreams (void) const;
-
+  /**
+   * Fill the coding field of HE-SIG-A2.
+   *
+   * \param ldpc whether LDPC is used or not
+   */
+  void SetCoding (bool ldpc);
+  /**
+   * Return whether LDPC is used or not.
+   *
+   * \return whether LDPC is used or not
+   */
+  bool IsLdpcCoding (void) const;
 
 private:
   //HE-SIG-A1 fields
@@ -441,6 +478,9 @@
   uint8_t m_gi_ltf_size;  ///< GI+LTF Size field
   uint8_t m_nsts;         ///< NSTS
 
+  //HE-SIG-A2 fields
+  uint8_t m_coding; ///< Coding (0 for BCC, 1 for LDPC)
+
   /// This is used to decide whether MU SIG-B should be added or not
   bool m_mu;
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-phy-state-helper.cc ns-3.33/src/wifi/model/wifi-phy-state-helper.cc
--- ns-3.32/src/wifi/model/wifi-phy-state-helper.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-phy-state-helper.cc	2021-01-09 10:19:23.000000000 -0800
@@ -354,11 +354,13 @@
 }
 
 void
-WifiPhyStateHelper::SwitchToTx (Time txDuration, Ptr<const Packet> packet, double txPowerDbm,
-                                WifiTxVector txVector)
+WifiPhyStateHelper::SwitchToTx (Time txDuration, WifiConstPsduMap psdus, double txPowerDbm, WifiTxVector txVector)
 {
-  NS_LOG_FUNCTION (this << txDuration << packet << txPowerDbm << txVector);
-  m_txTrace (packet, txVector.GetMode (), txVector.GetPreambleType (), txVector.GetTxPowerLevel ());
+  NS_LOG_FUNCTION (this << txDuration << psdus << txPowerDbm << txVector);
+  for (auto const& psdu : psdus)
+    {
+      m_txTrace (psdu.second->GetPacket (), txVector.GetMode (psdu.first), txVector.GetPreambleType (), txVector.GetTxPowerLevel ());
+    }
   Time now = Simulator::Now ();
   switch (GetState ())
     {
@@ -473,13 +475,13 @@
 }
 
 void
-WifiPhyStateHelper::SwitchFromRxEndOk (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu)
+WifiPhyStateHelper::SwitchFromRxEndOk (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, uint16_t staId, std::vector<bool> statusPerMpdu)
 {
   NS_LOG_FUNCTION (this << *psdu << snr << txVector << statusPerMpdu.size () <<
                    std::all_of(statusPerMpdu.begin(), statusPerMpdu.end(), [](bool v) { return v; })); //returns true if all true
   NS_ASSERT (statusPerMpdu.size () != 0);
   NS_ASSERT (m_endRx == Simulator::Now ());
-  m_rxOkTrace (psdu->GetPacket (), snr, txVector.GetMode (), txVector.GetPreambleType ());
+  m_rxOkTrace (psdu->GetPacket (), snr, txVector.GetMode (staId), txVector.GetPreambleType ());
   NotifyRxEndOk ();
   DoSwitchFromRx ();
   if (!m_rxOkCallback.IsNull ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-phy-state-helper.h ns-3.33/src/wifi/model/wifi-phy-state-helper.h
--- ns-3.32/src/wifi/model/wifi-phy-state-helper.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-phy-state-helper.h	2021-01-09 10:19:23.000000000 -0800
@@ -27,6 +27,7 @@
 #include "ns3/nstime.h"
 #include "wifi-phy-state.h"
 #include "wifi-preamble.h"
+#include "wifi-ppdu.h"
 
 namespace ns3 {
 
@@ -164,12 +165,12 @@
   /**
    * Switch state to TX for the given duration.
    *
-   * \param txDuration the duration of the TX
-   * \param packet the packet
+   * \param txDuration the duration of the PPDU to transmit
+   * \param psdus the PSDUs in the transmitted PPDU (only one unless it is a MU PPDU)
    * \param txPowerDbm the nominal TX power in dBm
-   * \param txVector the TX vector of the packet
+   * \param txVector the TX vector for the transmission
    */
-  void SwitchToTx (Time txDuration, Ptr<const Packet> packet, double txPowerDbm, WifiTxVector txVector);
+  void SwitchToTx (Time txDuration, WifiConstPsduMap psdus, double txPowerDbm, WifiTxVector txVector);
   /**
    * Switch state to RX for the given duration.
    *
@@ -196,9 +197,10 @@
    * \param psdu the successfully received PSDU
    * \param snr the SNR of the received PSDU in linear scale
    * \param txVector TXVECTOR of the PSDU
+   * \param staId the station ID of the PSDU (only used for MU)
    * \param statusPerMpdu reception status per MPDU
    */
-  void SwitchFromRxEndOk (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu);
+  void SwitchFromRxEndOk (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, uint16_t staId, std::vector<bool> statusPerMpdu);
   /**
    * Switch from RX after the reception failed.
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-ppdu.cc ns-3.33/src/wifi/model/wifi-ppdu.cc
--- ns-3.32/src/wifi/model/wifi-ppdu.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-ppdu.cc	2021-01-09 10:19:23.000000000 -0800
@@ -32,22 +32,51 @@
 WifiPpdu::WifiPpdu (Ptr<const WifiPsdu> psdu, WifiTxVector txVector, Time ppduDuration, WifiPhyBand band)
   : m_preamble (txVector.GetPreambleType ()),
     m_modulation (txVector.IsValid () ? txVector.GetMode ().GetModulationClass () : WIFI_MOD_CLASS_UNKNOWN),
-    m_psdu (psdu),
     m_truncatedTx (false),
     m_band (band),
     m_channelWidth (txVector.GetChannelWidth ()),
     m_txPowerLevel (txVector.GetTxPowerLevel ())
 {
+  NS_LOG_FUNCTION (this << *psdu << txVector << ppduDuration << band);
+  m_psdus.insert (std::make_pair (SU_STA_ID, psdu));
+  SetPhyHeaders (txVector, ppduDuration, band);
+}
+
+WifiPpdu::WifiPpdu (const WifiConstPsduMap & psdus, WifiTxVector txVector, Time ppduDuration, WifiPhyBand band)
+  : m_preamble (txVector.GetPreambleType ()),
+    m_modulation (txVector.IsValid () ? txVector.GetMode (psdus.begin()->first).GetModulationClass () : WIFI_MOD_CLASS_UNKNOWN),
+    m_psdus (psdus),
+    m_truncatedTx (false),
+    m_band (band),
+    m_channelWidth (txVector.GetChannelWidth ()),
+    m_txPowerLevel (txVector.GetTxPowerLevel ())
+{
+  NS_LOG_FUNCTION (this << psdus << txVector << ppduDuration << band);
+  if (m_preamble == WIFI_PREAMBLE_HE_MU)
+    {
+      m_muUserInfos = txVector.GetHeMuUserInfoMap ();
+    }
+  SetPhyHeaders (txVector, ppduDuration, band);
+}
+
+WifiPpdu::~WifiPpdu ()
+{
+}
+
+void
+WifiPpdu::SetPhyHeaders (WifiTxVector txVector, Time ppduDuration, WifiPhyBand band)
+{
   if (!txVector.IsValid ())
     {
       return;
     }
-  NS_LOG_FUNCTION (this << psdu << txVector << ppduDuration << band);
+  NS_LOG_FUNCTION (this << txVector << ppduDuration << band);
   switch (m_modulation)
     {
       case WIFI_MOD_CLASS_DSSS:
       case WIFI_MOD_CLASS_HR_DSSS:
         {
+          NS_ASSERT (m_psdus.size () == 1);
           m_dsssSig.SetRate (txVector.GetMode ().GetDataRate (22));
           Time psduDuration = ppduDuration - WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector);
           m_dsssSig.SetLength (psduDuration.GetMicroSeconds ());
@@ -56,12 +85,14 @@
       case WIFI_MOD_CLASS_OFDM:
       case WIFI_MOD_CLASS_ERP_OFDM:
         {
+          NS_ASSERT (m_psdus.size () == 1);
           m_lSig.SetRate (txVector.GetMode ().GetDataRate (txVector), m_channelWidth);
-          m_lSig.SetLength (psdu->GetSize ());
+          m_lSig.SetLength (m_psdus.at (SU_STA_ID)->GetSize ());
           break;
         }
       case WIFI_MOD_CLASS_HT:
         {
+          NS_ASSERT (m_psdus.size () == 1);
           uint8_t sigExtension = 0;
           if (m_band == WIFI_PHY_BAND_2_4GHZ)
             {
@@ -71,9 +102,10 @@
           m_lSig.SetLength (length);
           m_htSig.SetMcs (txVector.GetMode ().GetMcsValue ());
           m_htSig.SetChannelWidth (m_channelWidth);
-          m_htSig.SetHtLength (psdu->GetSize ());
+          m_htSig.SetHtLength (m_psdus.at (SU_STA_ID)->GetSize ());
           m_htSig.SetAggregation (txVector.IsAggregation ());
           m_htSig.SetShortGuardInterval (txVector.GetGuardInterval () == 400);
+          m_htSig.SetFecCoding (txVector.IsLdpc ());
           break;
         }
       case WIFI_MOD_CLASS_VHT:
@@ -90,6 +122,7 @@
             }
           m_vhtSig.SetSuMcs (txVector.GetMode ().GetMcsValue ());
           m_vhtSig.SetNStreams (txVector.GetNss ());
+          m_vhtSig.SetCoding (txVector.IsLdpc ());
           break;
         }
       case WIFI_MOD_CLASS_HE:
@@ -100,7 +133,7 @@
               sigExtension = 6;
             }
           uint8_t m = 0;
-          if (m_preamble == WIFI_PREAMBLE_HE_SU)
+          if ((m_preamble == WIFI_PREAMBLE_HE_SU) || (m_preamble == WIFI_PREAMBLE_HE_TB))
             {
               m = 2;
             }
@@ -108,26 +141,33 @@
             {
               m = 1;
             }
+          else
+            {
+              NS_ASSERT_MSG (false, "Unsupported preamble type");
+            }
           uint16_t length = ((ceil ((static_cast<double> (ppduDuration.GetNanoSeconds () - (20 * 1000) - (sigExtension * 1000)) / 1000) / 4.0) * 3) - 3 - m);
           m_lSig.SetLength (length);
-          m_heSig.SetMuFlag (m_preamble == WIFI_PREAMBLE_HE_MU);
-          m_heSig.SetMcs (txVector.GetMode ().GetMcsValue ());
+          if (m_preamble == WIFI_PREAMBLE_HE_MU)
+            {
+              m_heSig.SetMuFlag (true);
+            }
+          else if (m_preamble != WIFI_PREAMBLE_HE_TB)
+            {
+              m_heSig.SetMcs (txVector.GetMode ().GetMcsValue ());
+              m_heSig.SetNStreams (txVector.GetNss ());
+            }
           m_heSig.SetBssColor (txVector.GetBssColor ());
           m_heSig.SetChannelWidth (m_channelWidth);
           m_heSig.SetGuardIntervalAndLtfSize (txVector.GetGuardInterval (), 2/*NLTF currently unused*/);
-          m_heSig.SetNStreams (txVector.GetNss ());
+          m_heSig.SetCoding (txVector.IsLdpc ());
           break;
         }
         default:
-        NS_FATAL_ERROR ("unsupported modulation class");
-        break;
+          NS_FATAL_ERROR ("unsupported modulation class");
+          break;
     }
 }
 
-WifiPpdu::~WifiPpdu ()
-{
-}
-
 WifiTxVector
 WifiPpdu::GetTxVector (void) const
 {
@@ -294,7 +334,7 @@
           txVector.SetChannelWidth (m_htSig.GetChannelWidth ());
           txVector.SetNss (1 + (m_htSig.GetMcs () / 8));
           txVector.SetGuardInterval(m_htSig.GetShortGuardInterval () ? 400 : 800);
-          txVector.SetAggregation (m_htSig.GetAggregation ());
+          txVector.SetLdpc (m_htSig.IsLdpcFecCoding ());
           break;
         }
       case WIFI_MOD_CLASS_VHT:
@@ -303,7 +343,7 @@
           txVector.SetChannelWidth (m_vhtSig.GetChannelWidth ());
           txVector.SetNss (m_vhtSig.GetNStreams ());
           txVector.SetGuardInterval (m_vhtSig.GetShortGuardInterval () ? 400 : 800);
-          txVector.SetAggregation (m_psdu->IsAggregate ());
+          txVector.SetLdpc (m_vhtSig.IsLdpcCoding ());
           break;
         }
       case WIFI_MOD_CLASS_HE:
@@ -313,7 +353,7 @@
           txVector.SetNss (m_heSig.GetNStreams ());
           txVector.SetGuardInterval (m_heSig.GetGuardInterval ());
           txVector.SetBssColor (m_heSig.GetBssColor ());
-          txVector.SetAggregation (m_psdu->IsAggregate ());
+          txVector.SetLdpc (m_heSig.IsLdpcCoding ());
           break;
         }
       default:
@@ -321,13 +361,34 @@
         break;
     }
   txVector.SetTxPowerLevel (m_txPowerLevel);
+  txVector.SetAggregation (m_psdus.size () > 1 || m_psdus.begin ()->second->IsAggregate ());
+  for (auto const& muUserInfo : m_muUserInfos)
+    {
+      txVector.SetHeMuUserInfo (muUserInfo.first, muUserInfo.second);
+    }
   return txVector;
 }
 
 Ptr<const WifiPsdu>
-WifiPpdu::GetPsdu (void) const
+WifiPpdu::GetPsdu (uint8_t bssColor, uint16_t staId) const
 {
-  return m_psdu;
+  if (!IsMu ())
+    {
+      NS_ASSERT (m_psdus.size () == 1);
+      return m_psdus.at (SU_STA_ID);
+    }
+  else
+    {
+      if (bssColor == m_heSig.GetBssColor ())
+        {
+          auto it = m_psdus.find (staId);
+          if (it != m_psdus.end ())
+            {
+              return it->second;
+            }
+        }
+    }
+  return nullptr;
 }
 
 bool
@@ -384,7 +445,7 @@
               sigExtension = 6;
             }
           uint8_t m = 0;
-          if (m_preamble == WIFI_PREAMBLE_HE_SU)
+          if ((m_preamble == WIFI_PREAMBLE_HE_SU) || (m_preamble == WIFI_PREAMBLE_HE_TB))
             {
               m = 2;
             }
@@ -405,13 +466,25 @@
   return ppduDuration;
 }
 
+bool
+WifiPpdu::IsMu (void) const
+{
+  return ((m_preamble == WIFI_PREAMBLE_VHT_MU) || (m_preamble == WIFI_PREAMBLE_HE_MU) || (m_preamble == WIFI_PREAMBLE_HE_TB));
+}
+
+WifiModulationClass
+WifiPpdu::GetModulation (void) const
+{
+  return m_modulation;
+}
+
 void
 WifiPpdu::Print (std::ostream& os) const
 {
   os << "preamble=" << m_preamble
      << ", modulation=" << m_modulation
-     << ", truncatedTx=" << (m_truncatedTx ? "Y" : "N")
-     << ", PSDU=" << m_psdu;
+     << ", truncatedTx=" << (m_truncatedTx ? "Y" : "N");
+  IsMu () ? (os << ", " << m_psdus) : (os << ", PSDU=" << m_psdus.at (SU_STA_ID));
 }
 
 std::ostream & operator << (std::ostream &os, const WifiPpdu &ppdu)
@@ -420,4 +493,14 @@
   return os;
 }
 
+std::ostream & operator << (std::ostream &os, const WifiConstPsduMap &psdus)
+{
+  for (auto const& psdu : psdus)
+    {
+      os << "PSDU for STA_ID=" << psdu.first
+         << " (" << *psdu.second << ") ";
+    }
+  return os;
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-ppdu.h ns-3.33/src/wifi/model/wifi-ppdu.h
--- ns-3.32/src/wifi/model/wifi-ppdu.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-ppdu.h	2021-01-09 10:19:23.000000000 -0800
@@ -22,6 +22,7 @@
 #define WIFI_PPDU_H
 
 #include <list>
+#include <unordered_map>
 #include "ns3/nstime.h"
 #include "wifi-tx-vector.h"
 #include "wifi-phy-header.h"
@@ -31,6 +32,8 @@
 
 class WifiPsdu;
 
+typedef std::unordered_map <uint16_t /* staId */, Ptr<const WifiPsdu> /* PSDU */> WifiConstPsduMap;
+
 /**
  * \ingroup wifi
  *
@@ -41,7 +44,7 @@
 {
 public:
   /**
-   * Create a single user PPDU storing a PSDU.
+   * Create a SU PPDU storing a PSDU.
    *
    * \param psdu the PHY payload (PSDU)
    * \param txVector the TXVECTOR that was used for this PPDU
@@ -50,6 +53,16 @@
    */
   WifiPpdu (Ptr<const WifiPsdu> psdu, WifiTxVector txVector, Time ppduDuration, WifiPhyBand band);
 
+  /**
+   * Create a MU PPDU storing a vector of PSDUs.
+   *
+   * \param psdus the PHY payloads (PSDUs)
+   * \param txVector the TXVECTOR that was used for this PPDU
+   * \param ppduDuration the transmission duration of this PPDU
+   * \param band the WifiPhyBand used for the transmission of this PPDU
+   */
+  WifiPpdu (const WifiConstPsduMap & psdus, WifiTxVector txVector, Time ppduDuration, WifiPhyBand band);
+
   virtual ~WifiPpdu ();
 
   /**
@@ -57,20 +70,26 @@
    * \return the TXVECTOR of the PPDU.
    */
   WifiTxVector GetTxVector (void) const;
+
   /**
    * Get the payload of the PPDU.
+   * \param bssColor the BSS color of the PHY calling this function.
+   * \param staId the staId of the PHY calling this function.
    * \return the PSDU
    */
-  Ptr<const WifiPsdu> GetPsdu (void) const;
+  Ptr<const WifiPsdu> GetPsdu (uint8_t bssColor = 64, uint16_t staId = SU_STA_ID) const;
+
   /**
    * Return true if the PPDU's transmission was aborted due to transmitter switch off
    * \return true if the PPDU's transmission was aborted due to transmitter switch off
    */
   bool IsTruncatedTx (void) const;
+
   /**
    * Indicate that the PPDU's transmission was aborted due to transmitter switch off.
    */
   void SetTruncatedTx (void);
+
   /**
    * Get the total transmission duration of the PPDU.
    * \return the transmission duration of the PPDU
@@ -78,24 +97,47 @@
   Time GetTxDuration () const;
 
   /**
+   * Return true if the PPDU is a MU PPDU
+   * \return true if the PPDU is a MU PPDU
+   */
+  bool IsMu (void) const;
+
+  /**
+   * Get the modulation used for the PPDU.
+   * \return the modulation used for the PPDU
+   */
+  WifiModulationClass GetModulation (void) const;
+
+  /**
    * \brief Print the PPDU contents.
    * \param os output stream in which the data should be printed.
    */
   void Print (std::ostream &os) const;
 
+
 private:
-  DsssSigHeader m_dsssSig;          //!< the DSSS SIG PHY header
-  LSigHeader m_lSig;                //!< the L-SIG PHY header
-  HtSigHeader m_htSig;              //!< the HT-SIG PHY header
-  VhtSigHeader m_vhtSig;            //!< the VHT-SIG PHY header
-  HeSigHeader m_heSig;              //!< the HE-SIG PHY header
-  WifiPreamble m_preamble;          //!< the PHY preamble
-  WifiModulationClass m_modulation; //!< the modulation used for the transmission of this PPDU
-  Ptr<const WifiPsdu> m_psdu;       //!< the PSDU contained in this PPDU
-  bool m_truncatedTx;               //!< flag indicating whether the frame's transmission was aborted due to transmitter switch off
-  WifiPhyBand m_band;               //!< the WifiPhyBand used to transmit that PPDU
-  uint16_t m_channelWidth;          //!< the channel width used to transmit that PPDU in MHz
-  uint8_t m_txPowerLevel;           //!< the transmission power level (used only for TX and initializing the returned WifiTxVector)
+  /**
+   * Fill in the PHY headers.
+   *
+   * \param txVector the TXVECTOR that was used for this PPDU
+   * \param ppduDuration the transmission duration of this PPDU
+   * \param band the WifiPhyBand used for the transmission of this PPDU
+   */
+  void SetPhyHeaders (WifiTxVector txVector, Time ppduDuration, WifiPhyBand band);
+
+  DsssSigHeader m_dsssSig;                     //!< the DSSS SIG PHY header
+  LSigHeader m_lSig;                           //!< the L-SIG PHY header
+  HtSigHeader m_htSig;                         //!< the HT-SIG PHY header
+  VhtSigHeader m_vhtSig;                       //!< the VHT-SIG PHY header
+  HeSigHeader m_heSig;                         //!< the HE-SIG PHY header
+  WifiPreamble m_preamble;                     //!< the PHY preamble
+  WifiModulationClass m_modulation;            //!< the modulation used for the transmission of this PPDU
+  WifiConstPsduMap m_psdus;                    //!< the PSDUs contained in this PPDU
+  bool m_truncatedTx;                          //!< flag indicating whether the frame's transmission was aborted due to transmitter switch off
+  WifiPhyBand m_band;                          //!< the WifiPhyBand used to transmit that PPDU
+  uint16_t m_channelWidth;                     //!< the channel width used to transmit that PPDU in MHz
+  uint8_t m_txPowerLevel;                      //!< the transmission power level (used only for TX and initializing the returned WifiTxVector)
+  WifiTxVector::HeMuUserInfoMap m_muUserInfos; //!< the HE MU specific per-user information (to be removed once HE-SIG-B headers are implemented)
 };
 
 /**
@@ -107,6 +149,15 @@
  */
 std::ostream& operator<< (std::ostream& os, const WifiPpdu &ppdu);
 
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param psdus the PSDUs
+ * \returns a reference to the stream
+ */
+std::ostream & operator << (std::ostream &os, const WifiConstPsduMap &psdus);
+
 } //namespace ns3
 
 #endif /* WIFI_PPDU_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-remote-station-info.cc ns-3.33/src/wifi/model/wifi-remote-station-info.cc
--- ns-3.32/src/wifi/model/wifi-remote-station-info.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-remote-station-info.cc	2021-01-09 10:19:23.000000000 -0800
@@ -37,7 +37,7 @@
 double
 WifiRemoteStationInfo::CalculateAveragingCoefficient ()
 {
-  double retval = std::exp (static_cast<double> (m_lastUpdate.GetMicroSeconds () - Simulator::Now ().GetMicroSeconds ()) / m_memoryTime.GetMicroSeconds ());
+  double retval = std::exp ( ((m_lastUpdate - Now ()) / m_memoryTime).GetDouble () );
   m_lastUpdate = Simulator::Now ();
   return retval;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-remote-station-manager.cc ns-3.33/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.32/src/wifi/model/wifi-remote-station-manager.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-remote-station-manager.cc	2021-01-09 10:19:23.000000000 -0800
@@ -285,6 +285,19 @@
 }
 
 bool
+WifiRemoteStationManager::GetLdpcSupported (void) const
+{
+  if (GetHtSupported ())
+    {
+      Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (m_wifiPhy->GetDevice ());
+      Ptr<HtConfiguration> htConfiguration = device->GetHtConfiguration ();
+      NS_ASSERT (htConfiguration); //If HT is supported, we should have a HT configuration attached
+      return htConfiguration->GetLdpcSupported ();
+    }
+  return false;
+}
+
+bool
 WifiRemoteStationManager::GetShortGuardIntervalSupported (void) const
 {
   if (GetHtSupported ())
@@ -504,7 +517,6 @@
       v.SetNTx (1);
       v.SetNss (1);
       v.SetNess (0);
-      v.SetStbc (0);
       return v;
     }
   WifiTxVector txVector;
@@ -529,6 +541,7 @@
   else
     {
       txVector = DoGetDataTxVector (Lookup (address));
+      txVector.SetLdpc (txVector.GetMode ().GetModulationClass () < WIFI_MOD_CLASS_HT ? 0 : UseLdpcForDestination (address));
     }
   Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (m_wifiPhy->GetDevice ());
   Ptr<HeConfiguration> heConfiguration = device->GetHeConfiguration ();
@@ -571,7 +584,6 @@
                        GetMaxNumberOfTransmitStreams (),
                        0,
                        GetChannelWidthForTransmission (defaultMode, m_wifiPhy->GetChannelWidth ()),
-                       false,
                        false);
 }
 
@@ -591,7 +603,6 @@
         v.SetNTx (1);
         v.SetNss (1);
         v.SetNess (0);
-        v.SetStbc (0);
         return v;
     }
   return DoGetRtsTxVector (Lookup (address));
@@ -1219,6 +1230,28 @@
   return htCapabilities->GetGreenfield ();
 }
 
+bool
+WifiRemoteStationManager::GetLdpcSupported (Mac48Address address) const
+{
+  Ptr<const HtCapabilities> htCapabilities = LookupState (address)->m_htCapabilities;
+  Ptr<const VhtCapabilities> vhtCapabilities = LookupState (address)->m_vhtCapabilities;
+  Ptr<const HeCapabilities> heCapabilities = LookupState (address)->m_heCapabilities;
+  bool supported = false;
+  if (htCapabilities)
+    {
+      supported |= htCapabilities->GetLdpc ();
+    }
+  if (vhtCapabilities)
+    {
+      supported |= vhtCapabilities->GetRxLdpc ();
+    }
+  if (heCapabilities)
+    {
+      supported |= heCapabilities->GetLdpcCodingInPayload ();
+    }
+  return supported;
+}
+
 WifiMode
 WifiRemoteStationManager::GetDefaultMode (void) const
 {
@@ -1645,4 +1678,10 @@
   return (GetGreenfieldSupported () && GetGreenfieldSupported (dest) && !GetUseGreenfieldProtection ());
 }
 
+bool
+WifiRemoteStationManager::UseLdpcForDestination (Mac48Address dest) const
+{
+  return (GetLdpcSupported () && GetLdpcSupported (dest));
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-remote-station-manager.h ns-3.33/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.32/src/wifi/model/wifi-remote-station-manager.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-remote-station-manager.h	2021-01-09 10:19:23.000000000 -0800
@@ -276,6 +276,12 @@
    */
   bool GetGreenfieldSupported (void) const;
   /**
+   * Return whether the device has LDPC support enabled.
+   *
+   * \return true if LDPC support is enabled, false otherwise
+   */
+  bool GetLdpcSupported (void) const;
+  /**
    * Return whether the device has SGI support enabled.
    *
    * \return true if SGI support is enabled, false otherwise
@@ -410,6 +416,15 @@
    */
   bool GetGreenfieldSupported (Mac48Address address) const;
   /**
+   * Return whether the station supports LDPC or not.
+   *
+   * \param address the address of the station
+   *
+   * \return true if LDPC is supported by the station,
+   *         false otherwise
+   */
+  bool GetLdpcSupported (Mac48Address address) const;
+  /**
    * Return whether the station supports short PHY preamble or not.
    *
    * \param address the address of the station
@@ -852,6 +867,14 @@
    * \return whether HT greenfield should be used for a given destination address
    */
   bool UseGreenfieldForDestination (Mac48Address dest) const;
+  /**
+   * \returns whether LDPC should be used for a given destination address.
+   *
+   * \param dest the destination address
+   *
+   * \return whether LDPC should be used for a given destination address
+   */
+  bool UseLdpcForDestination (Mac48Address dest) const;
 
   /**
    * TracedCallback signature for power change events.
